﻿using System.Security.Cryptography;
using System.Text;

namespace CalendarNotepad.Extends
{
    /// <summary>
    /// 附件操作
    /// </summary>
    public static class PlusFile
    {
        /// <summary>
        /// 获取MD5码
        /// </summary>
        public static string GetMd5(string fileContent) {
            var ibs = Encoding.UTF8.GetBytes(fileContent);
            return GetMd5(ibs);
        }
        /// <summary>
        /// 获取MD5码
        /// </summary>
        public static string GetMd5(byte[] content) {
            using var md5 = MD5.Create();
            var md5bs = md5.ComputeHash(content);
            StringBuilder sb = new(md5bs.Length * 2);
            for(int i = 0;i < md5bs.Length;i++) {
                sb.Append(md5bs[i].ToString("X2"));
            }
            return sb.ToString();
        }
        /// <summary>
        /// 读取文件内容
        /// </summary>
        /// <param name="fullFilePath"></param>
        /// <returns></returns>
        public static byte[] LoadFile(string fullFilePath) {
            if(!File.Exists(fullFilePath)) {
                throw new FileNotFoundException();
            }
            var fileInfo = new FileInfo(fullFilePath);
            var fileSize = fileInfo.Length;
            if(fileSize > 4 * 1024 * 1024) {
                throw new OutOfMemoryException();
            }
            using FileStream fs = fileInfo.OpenRead();
            using BinaryReader br = new BinaryReader(fs);
            var length = (int)fs.Length;
            var buf = br.ReadBytes(length);
            return buf;
        }
        /// <summary>
        /// 写入文件内容
        /// </summary>
        /// <param name="fullFilePath"></param>
        /// <param name="content"></param>
        public static void SaveFile(string fullFilePath,byte[] content) {
            if(File.Exists(fullFilePath)) {
                File.Delete(fullFilePath);
            }
            using var fs = new FileStream(fullFilePath,FileMode.CreateNew,FileAccess.Write);
            using var bw = new BinaryWriter(fs);
            bw.Write(content);
            bw.Flush();
            bw.Close();
        }
    }
}
